//
//  RSVRShareBaseModel.h
//  RSVRSDK_public
//
//  Created by 林飞阳 on 2022/2/15.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

typedef NS_ENUM(NSInteger, RSVRShareType) {
    RSVRShareTypeMiniProgram    = 1, // 微信小程序
    RSVRShareTypeCopyLink       = 2, // 复制链接
    RSVRShareTypeTimeline       = 3, // 分享微信朋友圈
    RSVRShareTypeWXFriend       = 4, // 分享微信好友
};

@interface RSVRShareBaseModel : NSObject

/// 分享类型
@property (nonatomic, assign) RSVRShareType shareType;

/// icon 名字
@property (nonatomic, copy) NSString *iconName;

/// icon url
@property (nonatomic, copy) NSString *iconUrl;

/// 额外数据
/// @note 这个字段为 业务方 H5 跟 业务方客户端约定的 json 数据结构
/// VR SDK 会透传这个字段的数据
@property (nonatomic, strong) NSDictionary *extraData;

/// icon的base64形式，推荐
@property (nonatomic, copy) NSString *iconBase64String;

/// 将 extraData 数据转换成指定的 model 对象
/// @param shareModelClass model 对象, 需要 业务方的客户端定义
/// @note 内部使用 YYModel 进行转换
- (id _Nullable)convertToShareModel:(Class)shareModelClass;

@end

NS_ASSUME_NONNULL_END
